/*
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class Rax1GrammarAccess extends AbstractGrammarElementFinder {
	
	public class DepartmentElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax1.Department");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cShortNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cShortNameIDTerminalRuleCall_0_0 = (RuleCall)cShortNameAssignment_0.eContents().get(0);
		private final Keyword cHyphenMinusKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameSTRINGTerminalRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cPersonsKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cPersonsAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cPersonsPersonParserRuleCall_4_0 = (RuleCall)cPersonsAssignment_4.eContents().get(0);
		private final Keyword cCoursesKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Assignment cCoursesAssignment_6 = (Assignment)cGroup.eContents().get(6);
		private final RuleCall cCoursesCourseParserRuleCall_6_0 = (RuleCall)cCoursesAssignment_6.eContents().get(0);
		
		//Department:
		//	shortName=ID '-' name=STRING
		//	'Persons:'
		//	persons+=Person*
		//	'Courses:'
		//	courses+=Course*;
		@Override public ParserRule getRule() { return rule; }
		
		//shortName=ID '-' name=STRING 'Persons:' persons+=Person* 'Courses:' courses+=Course*
		public Group getGroup() { return cGroup; }
		
		//shortName=ID
		public Assignment getShortNameAssignment_0() { return cShortNameAssignment_0; }
		
		//ID
		public RuleCall getShortNameIDTerminalRuleCall_0_0() { return cShortNameIDTerminalRuleCall_0_0; }
		
		//'-'
		public Keyword getHyphenMinusKeyword_1() { return cHyphenMinusKeyword_1; }
		
		//name=STRING
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//STRING
		public RuleCall getNameSTRINGTerminalRuleCall_2_0() { return cNameSTRINGTerminalRuleCall_2_0; }
		
		//'Persons:'
		public Keyword getPersonsKeyword_3() { return cPersonsKeyword_3; }
		
		//persons+=Person*
		public Assignment getPersonsAssignment_4() { return cPersonsAssignment_4; }
		
		//Person
		public RuleCall getPersonsPersonParserRuleCall_4_0() { return cPersonsPersonParserRuleCall_4_0; }
		
		//'Courses:'
		public Keyword getCoursesKeyword_5() { return cCoursesKeyword_5; }
		
		//courses+=Course*
		public Assignment getCoursesAssignment_6() { return cCoursesAssignment_6; }
		
		//Course
		public RuleCall getCoursesCourseParserRuleCall_6_0() { return cCoursesCourseParserRuleCall_6_0; }
	}
	public class NameOrStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax1.NameOrString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cSTRINGTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//NameOrString:
		//	ID | STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//ID | STRING
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_1() { return cSTRINGTerminalRuleCall_1; }
	}
	public class PersonElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax1.Person");
		private final Assignment cNameAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cNameNameOrStringParserRuleCall_0 = (RuleCall)cNameAssignment.eContents().get(0);
		
		//Person:
		//	name=NameOrString;
		@Override public ParserRule getRule() { return rule; }
		
		//name=NameOrString
		public Assignment getNameAssignment() { return cNameAssignment; }
		
		//NameOrString
		public RuleCall getNameNameOrStringParserRuleCall_0() { return cNameNameOrStringParserRuleCall_0; }
	}
	public class CourseElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax1.Course");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cCodeAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cCodeIDTerminalRuleCall_0_0 = (RuleCall)cCodeAssignment_0.eContents().get(0);
		private final Keyword cHyphenMinusKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameNameOrStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cColonKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Assignment cAllocationsAssignment_4_0 = (Assignment)cGroup_4.eContents().get(0);
		private final RuleCall cAllocationsResourceAllocationParserRuleCall_4_0_0 = (RuleCall)cAllocationsAssignment_4_0.eContents().get(0);
		private final Group cGroup_4_1 = (Group)cGroup_4.eContents().get(1);
		private final Keyword cCommaKeyword_4_1_0 = (Keyword)cGroup_4_1.eContents().get(0);
		private final Assignment cAllocationsAssignment_4_1_1 = (Assignment)cGroup_4_1.eContents().get(1);
		private final RuleCall cAllocationsResourceAllocationParserRuleCall_4_1_1_0 = (RuleCall)cAllocationsAssignment_4_1_1.eContents().get(0);
		
		//Course:
		//	code=ID '-' name=NameOrString ':' (allocations+=ResourceAllocation (',' allocations+=ResourceAllocation)*)?;
		@Override public ParserRule getRule() { return rule; }
		
		//code=ID '-' name=NameOrString ':' (allocations+=ResourceAllocation (',' allocations+=ResourceAllocation)*)?
		public Group getGroup() { return cGroup; }
		
		//code=ID
		public Assignment getCodeAssignment_0() { return cCodeAssignment_0; }
		
		//ID
		public RuleCall getCodeIDTerminalRuleCall_0_0() { return cCodeIDTerminalRuleCall_0_0; }
		
		//'-'
		public Keyword getHyphenMinusKeyword_1() { return cHyphenMinusKeyword_1; }
		
		//name=NameOrString
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//NameOrString
		public RuleCall getNameNameOrStringParserRuleCall_2_0() { return cNameNameOrStringParserRuleCall_2_0; }
		
		//':'
		public Keyword getColonKeyword_3() { return cColonKeyword_3; }
		
		//(allocations+=ResourceAllocation (',' allocations+=ResourceAllocation)*)?
		public Group getGroup_4() { return cGroup_4; }
		
		//allocations+=ResourceAllocation
		public Assignment getAllocationsAssignment_4_0() { return cAllocationsAssignment_4_0; }
		
		//ResourceAllocation
		public RuleCall getAllocationsResourceAllocationParserRuleCall_4_0_0() { return cAllocationsResourceAllocationParserRuleCall_4_0_0; }
		
		//(',' allocations+=ResourceAllocation)*
		public Group getGroup_4_1() { return cGroup_4_1; }
		
		//','
		public Keyword getCommaKeyword_4_1_0() { return cCommaKeyword_4_1_0; }
		
		//allocations+=ResourceAllocation
		public Assignment getAllocationsAssignment_4_1_1() { return cAllocationsAssignment_4_1_1; }
		
		//ResourceAllocation
		public RuleCall getAllocationsResourceAllocationParserRuleCall_4_1_1_0() { return cAllocationsResourceAllocationParserRuleCall_4_1_1_0; }
	}
	public class ResourceAllocationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax1.ResourceAllocation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cPersonAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final CrossReference cPersonPersonCrossReference_0_0 = (CrossReference)cPersonAssignment_0.eContents().get(0);
		private final RuleCall cPersonPersonNameOrStringParserRuleCall_0_0_1 = (RuleCall)cPersonPersonCrossReference_0_0.eContents().get(1);
		private final Assignment cPercentageAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cPercentageINTTerminalRuleCall_1_0 = (RuleCall)cPercentageAssignment_1.eContents().get(0);
		private final Keyword cPercentSignKeyword_2 = (Keyword)cGroup.eContents().get(2);
		
		//ResourceAllocation:
		//	person=[Person|NameOrString] percentage=INT '%';
		@Override public ParserRule getRule() { return rule; }
		
		//person=[Person|NameOrString] percentage=INT '%'
		public Group getGroup() { return cGroup; }
		
		//person=[Person|NameOrString]
		public Assignment getPersonAssignment_0() { return cPersonAssignment_0; }
		
		//[Person|NameOrString]
		public CrossReference getPersonPersonCrossReference_0_0() { return cPersonPersonCrossReference_0_0; }
		
		//NameOrString
		public RuleCall getPersonPersonNameOrStringParserRuleCall_0_0_1() { return cPersonPersonNameOrStringParserRuleCall_0_0_1; }
		
		//percentage=INT
		public Assignment getPercentageAssignment_1() { return cPercentageAssignment_1; }
		
		//INT
		public RuleCall getPercentageINTTerminalRuleCall_1_0() { return cPercentageINTTerminalRuleCall_1_0; }
		
		//'%'
		public Keyword getPercentSignKeyword_2() { return cPercentSignKeyword_2; }
	}
	
	
	private final DepartmentElements pDepartment;
	private final NameOrStringElements pNameOrString;
	private final PersonElements pPerson;
	private final CourseElements pCourse;
	private final ResourceAllocationElements pResourceAllocation;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public Rax1GrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pDepartment = new DepartmentElements();
		this.pNameOrString = new NameOrStringElements();
		this.pPerson = new PersonElements();
		this.pCourse = new CourseElements();
		this.pResourceAllocation = new ResourceAllocationElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("tdt4250.ra.Rax1".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Department:
	//	shortName=ID '-' name=STRING
	//	'Persons:'
	//	persons+=Person*
	//	'Courses:'
	//	courses+=Course*;
	public DepartmentElements getDepartmentAccess() {
		return pDepartment;
	}
	
	public ParserRule getDepartmentRule() {
		return getDepartmentAccess().getRule();
	}
	
	//NameOrString:
	//	ID | STRING;
	public NameOrStringElements getNameOrStringAccess() {
		return pNameOrString;
	}
	
	public ParserRule getNameOrStringRule() {
		return getNameOrStringAccess().getRule();
	}
	
	//Person:
	//	name=NameOrString;
	public PersonElements getPersonAccess() {
		return pPerson;
	}
	
	public ParserRule getPersonRule() {
		return getPersonAccess().getRule();
	}
	
	//Course:
	//	code=ID '-' name=NameOrString ':' (allocations+=ResourceAllocation (',' allocations+=ResourceAllocation)*)?;
	public CourseElements getCourseAccess() {
		return pCourse;
	}
	
	public ParserRule getCourseRule() {
		return getCourseAccess().getRule();
	}
	
	//ResourceAllocation:
	//	person=[Person|NameOrString] percentage=INT '%';
	public ResourceAllocationElements getResourceAllocationAccess() {
		return pResourceAllocation;
	}
	
	public ParserRule getResourceAllocationRule() {
		return getResourceAllocationAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
